#include "StraightData.h"

#include <algorithm>


namespace Irensei {



void StraightData::Remake( const Board * board )
{
	straights.clear();

	for ( int y = 0; y < Board::MaxY; y++ ) {
		for ( int x = 0; x < Board::MaxX; x++ ) {
			Board::EStone stone = board->Get( x, y );
			// ΂Ύ
			if ( stone == Board::EStoneSpace || stone == Board::EStoneOutOfBounds )
				continue;
			Straight straight;
			straight.idx = straights.size();
			straight.color = stone;
			for ( int dir = EDirFirst; dir < EDirLast; dir++ ) {
				straight.dir = static_cast<EDirection>(dir);
				if ( 2 <= MakeStraight( straight, board, x, y, static_cast<EDirection>(dir) ) ) {
					straights.insert( straight );
				}
			}
		}
	}
}


StraightData::Straight::Straight()
{
	outer = &firstend;
}
StraightData::Straight::Straight( const Straight & o )
		:
	idx(o.idx),
	color(o.color),
	dir(o.dir),
	length(o.length),
	firstend(o.firstend),
	lastend(o.lastend),
	firststop(o.firststop),
	laststop(o.laststop),
	outer((o.outer == &o.firstend) ? &firstend : &lastend),
	outdist(o.outdist)
{
}


namespace /* no names*/ {
	// A𐔂
	int CountStraight(
		StraightData::Position & dest, 
		const Irensei::Board * board, int x, int y, const StraightData::delta & d,
		const Board::EStone me
	) {
		int len = 0;
		x += d.x;		y += d.y;		// Jn_𐔂Ȃ
		while ( board->Get( x, y ) == me ) {
			len++;
			// V̂̂ōXV
			dest.x = x;
			dest.y = y;
			x += d.x;	y += d.y;
		};
		return len;
	}

	// P̋ԂB
	int outdist( const StraightData::Position & pos ) 
	{
		int cx = (Irensei::Board::MaxX / 2);
		int cy = (Irensei::Board::MaxY / 2);
		int h = cx - std::abs( pos.x - cx )/*S̋*/;	// [̋
		int v = cy - std::abs( pos.y - cy )/*S̋*/;	// [̋
		return std::min( h, v );
	} 
}

// _^ƘA_Ԃ܂
int StraightData::MakeStraight( 
	StraightData::Straight & straight, 		// o
	const Board * board, int x, int y, 		// ՖʂƌJnʒu
	StraightData::EDirection dir 			// 
)
{
	const Board::EStone me = board->Get( x, y );
	straight.firstend.x = x;	straight.firstend.y = y;
	straight.lastend.x = x;		straight.lastend.y = y;

	int len = 1;

	// last 
	delta d = GetDelta( dir );
	const int lastlen = CountStraight( straight.lastend, board, x, y, d, me );
	straight.laststop = board->Get( x + d.x*(lastlen+1), y + d.y*(lastlen+1) );

	// first 
	d *= -1;				// 𔽓]
	const int firstlen = CountStraight( straight.firstend, board, x, y, d, me );
	straight.firststop = board->Get( x + d.x*(firstlen+1), y + d.y*(firstlen+1) );

	len = len + lastlen + firstlen;
	straight.length = len;

	// Oɋ߂̂𓾂
	{
		straight.outer = &straight.firstend;
		straight.outdist = outdist( straight.firstend );
		if ( len == 1 ) {
			// lastend Ɠꂾ firstend ̂ŖȂ
		} else {
			// lastend ̂ƔׂāAlastend ̂قOȂ lastend ̗p
			int lastod = outdist( straight.lastend );
			if ( lastod < straight.outdist ) {
				straight.outdist = lastod;
				straight.outer = & straight.lastend;
			}
		}
	}

	return len;
}

StraightData::delta StraightData::GetDelta( StraightData::EDirection dir )
{
	static delta directions[ EDirLast+1 ] = {
		{ 100,100 },/*  EDirNone */
		{ 1, 0 }, { 0, 1 }, { 1, -1 }, { 1, 1 },
		{ 100,100 },/*  EDirLast */
	};

	return directions[ dir ];
}






} /* namespace Irensei */
