#include "VirtualStraight.h"


namespace Irensei {


void VirtualStraightData::Remake( const Board * board, const int limitlen )
{
	vstraights.clear();

	for ( int y = 0; y < Board::MaxY; y++ ) {
		for ( int x = 0; x < Board::MaxX; x++ ) {
			Board::EStone stone = board->Get( x, y );
			// ΂Ύ
			if ( stone == Board::EStoneSpace || stone == Board::EStoneOutOfBounds )
				continue;
			VirtualStraight vst;
			vst.idx = vstraights.size();
			vst.color = stone;
			for ( int dir = EDirFirst; dir < EDirLast; dir++ ) {
				vst.dir = static_cast<EDirection>(dir);
				if ( 2 <= MakeVirtualStraight( vst, board, x, y, static_cast<EDirection>(dir), limitlen ) ) {
					vstraights.insert( vst );
				}
			}
		}
	}
	// d폜
	for ( std::set<VirtualStraight>::iterator vstr = vstraights.begin(); vstr != vstraights.end(); vstr++ ) {
		const delta d = GetDelta( vstr->dir );
		std::set<VirtualStraight>::iterator itor = vstr;
		for ( itor++; itor != vstraights.end(); ) {
			if ( vstr->dir != itor->dir || vstr->color != itor->color ) {
				itor++;
				continue;
			}
			bool flagMatchLine = false;
			switch ( itor->dir ) {
				case EDirHolizontal:	flagMatchLine = (vstr->firstend.y == itor->firstend.y);	break;
				case EDirVertical:		flagMatchLine = (vstr->firstend.x == itor->firstend.x);	break;
				case EDirRUp:			flagMatchLine = (vstr->firstend.x+vstr->firstend.y == itor->firstend.x+itor->firstend.y);	break;
				case EDirRDown:			flagMatchLine = (vstr->firstend.x-vstr->firstend.y == itor->firstend.x-itor->firstend.y);	break;
			}
			if ( ! flagMatchLine ) {
				itor++;
				continue;
			}
			std::set<VirtualStraight>::iterator next = itor;
			next++;
			Position pos = vstr->firstend + d;
			for ( int lpc = 1; vstr->length - itor->length > lpc; lpc++ ) {
				if ( pos == itor->firstend ) {
					vstraights.erase( itor );
					break;
				}
			}
			itor = next;
		}
	}
}


VirtualStraightData::VirtualStraight::VirtualStraight()
{
	outer = inner = &firstend;
}
VirtualStraightData::VirtualStraight::VirtualStraight( const VirtualStraight & o )
		:
	idx(o.idx),
	color(o.color),
	dir(o.dir),
	length(o.length),
	cntStones(o.cntStones),
	spaces(o.spaces),
	firstend(o.firstend),
	lastend(o.lastend),
	firststop(o.firststop),
	laststop(o.laststop),
	outer( (o.outer == &o.firstend) ? &firstend : &lastend ),
	inner( (o.inner == &o.firstend) ? &firstend : &lastend ),
	outdist( o.outdist )
{
}




namespace /* no names*/ {
	// A𐔂
	int CountVirtualStraight(
		VirtualStraightData::Position & dest, 
		const Irensei::Board * board, int x, int y, const VirtualStraightData::delta & d,
		const Board::EStone me, const int limitlen/*ȏ͐Ȃ*/
	) {
		// ՊO⑊̐΂܂ŒTčŌɌ me
		int len = 0;
		int lastlen = 0;
		x += d.x;		y += d.y;		// Jn_𐔂Ȃ
		while ( len < limitlen ) {
			const Board::EStone stone = board->Get( x, y );
			if ( stone & ~me )
				break;
			len++;
			if ( stone == me ) {
				lastlen = len;
				dest.x = x;
				dest.y = y;
			}
			x += d.x;	y += d.y;
		}
		return lastlen;
	}

	// P̋ԂB
	int outdist( const StraightData::Position & pos ) 
	{
		int cx = (Irensei::Board::MaxX / 2);
		int cy = (Irensei::Board::MaxY / 2);
		int h = cx - std::abs( pos.x - cx )/*S̋*/;	// [̋
		int v = cy - std::abs( pos.y - cy )/*S̋*/;	// [̋
		return std::min( h, v );
	} 
}

int VirtualStraightData::MakeVirtualStraight( 
	VirtualStraightData::VirtualStraight & straight,// o
	const Board * board, int x, int y, 				// ՖʂƌJnʒu
	VirtualStraightData::EDirection dir, 			// 
	const int limitlen
)
{
	const Board::EStone me = board->Get( x, y );
	straight.firstend.x = x;	straight.firstend.y = y;
	straight.lastend.x = x;		straight.lastend.y = y;

	// last 
	delta d = GetDelta( dir );
	const int len = CountVirtualStraight( straight.lastend, board, x, y, d, me, limitlen-1 ) + 1/*Tn߂̐*/;
	straight.laststop = board->Get( x + d.x*len, y + d.y*len );
	straight.firststop = board->Get( x-d.x, y-d.y );

	straight.length = len;

	// Oɋ߂̂𓾂
	{
		straight.inner = &straight.lastend;
		straight.outer = &straight.firstend;
		straight.outdist = outdist( straight.firstend );
		if ( len == 1 ) {
			// lastend Ɠꂾ firstend ̂ŖȂ
		} else {
			// lastend ̂ƔׂāAlastend ̂قOȂ lastend ̗p
			int lastod = outdist( straight.lastend );
			if ( lastod < straight.outdist ) {
				straight.outdist = lastod;
				straight.inner = & straight.firstend;
				straight.outer = & straight.lastend;
			}
		}
	}

	// spaces
	{
		Position pos;
		pos.x = x;
		pos.y = y;
		pos += GetDelta( dir );
		for ( int lpc = 1; lpc <= (len - 2); lpc++ ) {	// end Kv͖
			if ( board->Get( pos.x, pos.y ) == Board::EStoneSpace )
				straight.spaces.push_back( pos );
			pos += GetDelta( dir );
		}
	}

	return len;
}




} /* namespace Irensei */
