//---------------------------------------------------------------------------

#include <vcl.h>
#include <Clipbrd.hpp>
#include <mmsystem.h>
#pragma hdrstop

#include "mainform.h"
#include "GameConditionDlg2.h"
#include "RuleChangingDlg.h"
#include "DebugIDDlg.h"
#include "Splash.h"
#include "board.h"
#include "irensei_rule_description.h"
#include "irensei_ai_descripter.h"
#include "ai.h"
#include "StringData.h"
#include "CheckReach.h"
#include "VirtualStraight.h"
#include <string>
#include <assert.h>
#include <ddraw.h>
#include <vcl\Clipbrd.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TIrenseiMainForm *IrenseiMainForm;
using namespace Irensei;

static const char * windowTitle = "͘A";

static const int BoardImageLineStep = 22;
static const int BoardImageLeftLine = 18;
static const int BoardImageTopLine = 61;
static const int StoneImageSize = 21;

extern const char stoneImageBlackNormal[];
extern const char stoneImageBlackReach[];
extern const char stoneImageBlackDying[];
extern const char stoneImageBlackLast[];
extern const char stoneImageWhiteNormal[];
extern const char stoneImageWhiteReach[];
extern const char stoneImageWhiteDying[];
extern const char stoneImageWhiteGoal[];
extern const char stoneImageWhiteLast[];
extern const char starImageGoal[];
extern const char starImageReachPoint[];
extern const char starImageDeathPoint[];



const char * TIrenseiMainForm::getNormalStoneImage( Board::EStone stone )
{
	return (stone == Game::EBWBlack) ? 
			stoneImageBlackNormal :
			stoneImageWhiteNormal;
}
const char * TIrenseiMainForm::getReachStoneImage( Board::EStone stone )
{
	return (stone == Game::EBWBlack) ? 
			stoneImageBlackReach :
			stoneImageWhiteReach;
}
const char * TIrenseiMainForm::getDyingStoneImage( Board::EStone stone )
{
	return (stone == Game::EBWBlack) ? 
			stoneImageBlackDying :
			stoneImageWhiteDying;
}
const char * TIrenseiMainForm::getGoalMarkImage( Board::EStone stone )
{
	return starImageGoal;
}
const char * TIrenseiMainForm::getLastStoneImage( Board::EStone stone )
{
	return (stone == Game::EBWBlack) ? 
			stoneImageBlackLast :
			stoneImageWhiteLast;
}
const char * TIrenseiMainForm::getAtariPointImage( Board::EStone )
{
	return starImageDeathPoint;
}
const char * TIrenseiMainForm::getReachPointImage( Board::EStone )
{
	return starImageReachPoint;
}





#ifdef _DEBUG
# define ASSERT(x)	assert(x)
#else
# define ASSERT(x)	
#endif


//---------------------------------------------------------------------------
// TEh
const char * lockWaveResource( const char * resname, HANDLE & hOut ) 	// ߂l Lock |C^A hOut Ɏ擾\[Xnh
{
	hOut = 0;

    /* Find the WAVE resource. */
    HANDLE hResInfo = FindResource(HInstance, resname, "WAVE");
    if (hResInfo == NULL) {
        ShowMessage( "can't FindResource(HInstance, \"IDWAV_MAIN WAVE\", \"WAVE\")." );
        return 0;
    }

    /* Load the WAVE resource. */
    hOut = LoadResource(HInstance, hResInfo);
    if (hOut == NULL) {
        ShowMessage( "can't LoadResource(HInstance, hResInfo)." );
        hOut = 0;
        return 0;
	}

    const char * locked = (char*)LockResource(hOut);
    if ( ! locked )
    	FreeResource(hOut);
	return locked;
}
//---------------------------------------------------------------------------
// ԕ\
class SignBoard {
	SignBoard();		// ֎~
	enum EState {
		ESInactive,
		ESActive,
		ESWin,
		ESMax
	};
public:
	enum EType {
		ETCpu,
		ETSame,
		ETUser,
		ETNone,
	};

	SignBoard( TImage * owner, TImage * imgs, int left, int top ) : Owner(owner), Images(imgs), type(ETNone), x(left), y(top)	{};

	void SetType( EType t )		{ type = t; }

	void Change( bool active/*EState state*/ ) {
		if ( Images && type != ETNone ) {
			Owner->Invalidate();
			const int idx = type*2 + (active ? 0 : 1);
			const int width = Images->Picture->Bitmap->Width;
			const int height = 36/*@@MAGIC!!*/;
			Owner->Canvas->CopyRect( TRect( x, y, x + width, y + height ), Images->Canvas, TRect( 0, idx*height, width, (idx+1)*height ) );
			Owner->Update();
		}
	}
private:
	EType type;
	int x;
	int y;
	TImage * Owner;
	TImage * Images;	// user inactive, user active, com inactive, com active ̏
};
//---------------------------------------------------------------------------
__fastcall TIrenseiMainForm::TIrenseiMainForm(TComponent* Owner)
	: TForm(Owner)
{
	// R|[lg̏

	buttonUnderPressed = 0;
	newgameButton = new GameButton( Rect(4,118,68,182), RightPaneImage, NewgameButtonImages, &newgameButtonPressed );
	gameButtons.push_back( newgameButton );
	undoButton = new GameButton( Rect(71,118,135,182), RightPaneImage, UndoButtonImages, &undoButtonPressed );
	gameButtons.push_back( undoButton );
	resignButton = new GameButton( Rect(138,118,202,182), RightPaneImage, ResignButtonImages, &resignButtonPressed );
	gameButtons.push_back( resignButton );
	logoButton = new GameButton( Rect(8,16,200,96), RightPaneImage, 0, &logoButtonPressed );
	gameButtons.push_back( logoButton );
	blackSignBoard = new SignBoard( RightPaneImage, BlackSignImages, 4, 205 );
	whiteSignBoard = new SignBoard( RightPaneImage, WhiteSignImages, 4, 246 );

	ExportToFileDialog->InitialDir = ExtractFilePath( ParamStr(0) );

	Caption = windowTitle;

	RightPaneImage->Invalidate();
	RightPaneImage->Canvas->CopyMode = cmSrcCopy;
	RightPaneImage->Picture->Bitmap->PixelFormat = pf24bit;
	RightPaneImage->Picture->Bitmap->Width = RightPaneImage->Width;
	RightPaneImage->Picture->Bitmap->Height = RightPaneImage->Height;
	RightPaneImage->Canvas->CopyRect( RightPaneImage->Canvas->ClipRect, RightPaneImageHolder->Canvas, RightPaneImageHolder->Canvas->ClipRect );
	RightPaneImage->Update();

	pResSoundMove   = lockWaveResource( "IDWAV_MOVE", hResSoundMove );
	pResSoundButton = lockWaveResource( "IDWAV_BUTTON", hResSoundButton );
	pResSoundJingle = lockWaveResource( "IDWAV_JINGLE", hResSoundJingle );


	// Q[Iȏ

	AIParam & blackAI = players[ Game::EBWBlack ].ai;
	AIParam & whiteAI = players[ Game::EBWWhite ].ai;
	blackAI.param = 0;
	whiteAI.param = 0;
	SetLogPipe( players[ Game::EBWBlack ] );
	SetLogPipe( players[ Game::EBWWhite ] );
	players[ Game::EBWBlack ].signboard = blackSignBoard;
	players[ Game::EBWWhite ].signboard = whiteSignBoard;
	players[ Game::EBWBlack ].color = "";
	players[ Game::EBWWhite ].color = "";
	players[ Game::EBWBlack ].ai.logWindow->Caption = "";
	players[ Game::EBWWhite ].ai.logWindow->Caption = "";

	// AvP[V̓IȂ

	StopGame();
	MakeDefaultIrenseiRuleDescriptionVer100( &rule99 );
	rule99.version = 99;
	MakeDefaultIrenseiRuleDescriptionVer100( &rule100 );
	currule = &rule99;

	game.Reset();


	flagThinking = false;
	flagEndGame = true;

	DebugID = -1;
	memset( dbBoard.stones, -128, sizeof(dbBoard.stones) );
	debugFontColor = DebugFontColorDialog->Color;
	shadowedDebugFontColor = DebugFontShadowColorDialog->Color;

	UpdateImage();
}

//---------------------------------------------------------------------------
__fastcall TIrenseiMainForm::~TIrenseiMainForm()
{
	CloseHandle( players[ Game::EBWBlack ].ai.hout );
	CloseHandle( players[ Game::EBWWhite ].ai.hout );

	for ( std::vector<GameButton*>::iterator itor = gameButtons.begin(); itor != gameButtons.end(); itor++ ) {
		delete *itor;
	}
	delete blackSignBoard;
	delete whiteSignBoard;

	UnlockResource(hResSoundMove);
    FreeResource(hResSoundMove);
	UnlockResource(hResSoundButton);
    FreeResource(hResSoundButton);
	UnlockResource(hResSoundJingle);
    FreeResource(hResSoundJingle);
}
//---------------------------------------------------------------------------
void TIrenseiMainForm::SetLogPipe( PlayerDesc & desc )
{
	HANDLE hRead, hWrite;
	if ( ! CreatePipe( &hRead, &hWrite, 0, 0 ) ) {
		hWrite = CreateFile( "NUL", GENERIC_WRITE, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);;
	}
	else {
		desc.ai.logWindow = new TIrenseiLogWindow( this, hRead );
		desc.ai.hout = hWrite;
	}
}

//---------------------------------------------------------------------------
void draw_dds( Graphics::TBitmap * bitmap, int left, int top, const void * dds )
{
	if ( bitmap->PixelFormat != pf24bit && bitmap->PixelFormat != pf32bit )
		return;
	const int destbpp = (bitmap->PixelFormat == pf24bit) ? 3 : 4;

	const int * const magic = reinterpret_cast<const int *>( dds );
	const DDSURFACEDESC2 * const head = reinterpret_cast<const DDSURFACEDESC2 *>( magic + 1/*skip FOURCC magic 'DDS '*/ );
	if ( *magic != MAKEFOURCC('D','D','S',' ') )
		return;

	const DDPIXELFORMAT * pixfotmat = &head->ddpfPixelFormat;
	if ( !(pixfotmat->dwFlags & DDPF_RGB) || pixfotmat->dwRGBBitCount != 32 )
		return;

	const int requiremask = DDSD_CAPS | DDSD_PIXELFORMAT | DDSD_WIDTH | DDSD_HEIGHT;
	if ( (head->dwFlags & requiremask) != requiremask )
		return;

	const unsigned char * pixtop = reinterpret_cast<const unsigned char*>((int)dds + 128/*@@MAGIC!!*/);
	const int w = head->dwWidth;
	const int h = head->dwHeight;
	const int pitch = (head->dwFlags & DDSD_PITCH) ? head->lPitch : w;
	const int srcbpp = 4/*@@MAGIC!! bytes/pixel*/;

	int y = top;
	for ( int srcy = 0; srcy < h; srcy++, y++ ) {
		int x = left;
		const unsigned char * srcline = pixtop + srcy * pitch * srcbpp;
		unsigned char * destline = reinterpret_cast<unsigned char *>(bitmap->ScanLine[ y ]);
		for ( int srcx = 0; srcx < h; srcx++, x++ ) {
			int r0    = srcline[ srcx * srcbpp + 0 ];
			int g0    = srcline[ srcx * srcbpp + 1 ];
			int b0    = srcline[ srcx * srcbpp + 2 ];
			int alpha = srcline[ srcx * srcbpp + 3 ];
			int r1 = destline[ x * destbpp + 0 ];
			int g1 = destline[ x * destbpp + 1 ];
			int b1 = destline[ x * destbpp + 2 ];
			destline[ x * destbpp + 0 ] = r1 + (r0 - r1) * alpha / 255;
			destline[ x * destbpp + 1 ] = g1 + (g0 - g1) * alpha / 255;
			destline[ x * destbpp + 2 ] = b1 + (b0 - b1) * alpha / 255;
		}
	}
}
//---------------------------------------------------------------------------
void TIrenseiMainForm::UpdateImage( void )
{
	BoardImage->Invalidate();

	BoardImage->Picture->Bitmap->PixelFormat = pf24bit;
	BoardImage->Picture->Bitmap->Width = 432;
	BoardImage->Picture->Bitmap->Height = 518;
	TCanvas * canvas = BoardImage->Picture->Bitmap->Canvas;
	canvas->CopyMode = cmSrcCopy;

	// Ֆʂ̃Rs[
	canvas->CopyRect( canvas->ClipRect, BoardImageHolder->Canvas, BoardImageHolder->Canvas->ClipRect );

	const Board * board = game.GetBoard( MovesList->ItemIndex );
	const int step = BoardImageLineStep;
	const int left = BoardImageLeftLine;
	const int top = BoardImageTopLine;

	// ΂ł
	for ( int x = 0; Board::MaxX > x; x++ ) {
		for ( int y = 0; Board::MaxY > y; y++ ) {
			Board::EStone stone = board->Get( x, y );
			if ( stone == Board::EStoneSpace )
				continue;
			int sx = left + x*step - StoneImageSize/2;
			int sy = top + y*step - StoneImageSize/2;
			draw_dds( BoardImage->Picture->Bitmap, sx, sy, getNormalStoneImage( stone ) );
		}
	}

	// 菇\


	DrawLastMove();

	// qg\
	if ( (! flagEndGame || (MovesList->ItemIndex != MovesList->Count-1) ) && 
			/*DebugID < 0 && */game.NextOrder() != Game::EBWNone 
	) {
		DrawReaches( board );
		DrawAtari( board );
	}
	DrawGoal( board );

	// AI fobO\
	if ( DebugID >= 0 )
		DrawDebugBoard( canvas );

	BoardImage->Update();
}


void TIrenseiMainForm::DrawAtari( const Board * board )
{
	if ( ! AtariMenu->Checked )
		return;

	const int step = BoardImageLineStep;
	const int left = BoardImageLeftLine;
	const int top = BoardImageTopLine;

	StringData strings( board );
	for ( std::vector< StringData::String >::const_iterator itor = strings.strings.begin(); itor != strings.strings.end(); itor++ ) {
		if ( itor->breathPoints.size() == 1 ) {
			const StringData::Position & pos = *itor->breathPoints.begin();

			const int sx = left + pos.x*step - StoneImageSize / 2;
			const int sy = top + pos.y*step - StoneImageSize / 2;
			draw_dds( BoardImage->Picture->Bitmap, sx, sy, getAtariPointImage(itor->color) );
			const char * dyingImage = getDyingStoneImage( itor->color );
			for ( std::set< StringData::Position >::const_iterator stone = itor->stones.begin(); stone != itor->stones.end(); stone++ ) {
				const int sx = left + stone->x*step - StoneImageSize / 2;
				const int sy = top + stone->y*step - StoneImageSize / 2;
				draw_dds( BoardImage->Picture->Bitmap, sx, sy, dyingImage );
			}
		}
	}
}


void TIrenseiMainForm::DrawReaches( const Board * board )
{
	const int step = BoardImageLineStep;
	const int left = BoardImageLeftLine;
	const int top = BoardImageTopLine;
	const int ofx = StoneImageSize / 2;
	const int ofy = StoneImageSize / 2;

	bool reach0 = ReachMenu->Checked;
	bool reach1 = ReachFor1Menu->Checked;
	bool reach2 = ReachFor2Menu->Checked;
	if ( reach2 ) {
	}
	if ( reach1 ) {
	}

	if ( reach0 ) {
		IRENSEI_DEBUG_BOARD blackReach, whiteReach;
		Check0Reach( blackReach, board, *currule, Game::EBWBlack );
		Check0Reach( whiteReach, board, *currule, Game::EBWWhite );

		for ( int y = 0; y < Board::MaxY; y++ ) {
			for ( int x = 0; x < Board::MaxX; x++ ) {
				if ( blackReach.stones[y][x] == 0 ) {
					draw_dds( BoardImage->Picture->Bitmap, left + x*step - ofx, top + y*step - ofy, getReachPointImage( Board::EStoneBlack ) );
				}
				else if (whiteReach.stones[y][x] == 0 ) {
					draw_dds( BoardImage->Picture->Bitmap, left + x*step - ofx, top + y*step - ofy, getReachPointImage( Board::EStoneWhite ) );
				}
				else if ( blackReach.stones[y][x] != -128 ) {
					draw_dds( BoardImage->Picture->Bitmap, left + x*step - ofx, top + y*step - ofy, getReachStoneImage( Board::EStoneBlack ) );
				}
				else if ( whiteReach.stones[y][x] != -128 ) {
					draw_dds( BoardImage->Picture->Bitmap, left + x*step - ofx, top + y*step - ofy, getReachStoneImage( Board::EStoneWhite ) );
				}
			}
		}
	}
}


void TIrenseiMainForm::DrawGoal( const Irensei::Board * board )		// VA\
{
	const int step = BoardImageLineStep;
	const int left = BoardImageLeftLine;
	const int top = BoardImageTopLine;
	const int ofx = StoneImageSize / 2;
	const int ofy = StoneImageSize / 2;

	StraightData straights( board );

	const int outer = currule->outerInvalidLines;
	const int len = currule->lineLength;
	for ( std::set<StraightData::Straight>::const_iterator itor = straights.straights.begin(); itor != straights.straights.end(); itor++ ) {
		if ( itor->length < len )
			continue;
		if ( itor->color == Board::EStoneBlack ) {		// A`FbN
			if ( itor->length > len || itor->outer->isOuterOf( outer ) )
				continue;
		}
		else {											// OĂVAɂȂ邩
			if ( itor->outer->isOuterOf( outer ) ) {
				int length = itor->length;
				for ( int lpc = 0; 2 > lpc; lpc++ ) {
					if ( ! itor->ends[lpc].isOuterOf( outer ) )
						continue;
					int x = itor->ends[lpc].x;
					int y = itor->ends[lpc].y;
					if ( x > Board::MaxX /2 )
						x = Board::MaxX-1 - x;
					if ( y > Board::MaxX /2 )
						y = Board::MaxX-1 - y;
					int out = outer - std::min( x, y )/*O*/;
					length -= out;
				}
				if ( length < len )
					continue;		// ͂ݏolƁAVAɂȂȂ
			}
		}
		const char * image = getGoalMarkImage( itor->color );
		StraightData::Position pos = itor->firstend;
		const StraightData::delta d = StraightData::GetDelta( itor->dir );
		for ( int lpc = 0; itor->length > lpc; lpc++, pos += d ) {
			if ( pos.isOuterOf( outer ) )
				continue;
			draw_dds( BoardImage->Picture->Bitmap, left + pos.x*step - ofx, top + pos.y*step - ofy, image );
		}
	}
}


void TIrenseiMainForm::DrawLastMove( void )
{
	if ( ! LastMoveMenu->Checked || MovesList->ItemIndex == -1 )
		return;
	Game::Move move = game.GetMove( MovesList->ItemIndex );
	const int sx = BoardImageLeftLine + move.x*BoardImageLineStep - StoneImageSize / 2;
	const int sy = BoardImageTopLine + move.y*BoardImageLineStep - StoneImageSize / 2;
	draw_dds( BoardImage->Picture->Bitmap, sx, sy, getLastStoneImage(Game::OrderToStone( move.blackOrWhite )) );
}



void TIrenseiMainForm::DrawDebugBoard( TCanvas * canvas ) const
{
	std::auto_ptr<Graphics::TBitmap> mask( new Graphics::TBitmap );
	std::auto_ptr<Graphics::TBitmap> str( new Graphics::TBitmap );
	std::auto_ptr<Graphics::TBitmap> shadow( new Graphics::TBitmap );
	int cw = StoneImageSize;
	int ch = StoneImageSize;
	mask->Width = cw;	str->Width = cw;	shadow->Width = cw;
	mask->Height = ch;	str->Height = ch;	shadow->Height = ch;
	mask->PixelFormat = pf8bit;
	str->PixelFormat = pf8bit;
	shadow->PixelFormat = pf8bit;
	TFontStyles bold = TFontStyles() << fsBold;
	mask->Canvas->Font->Style = bold;
	mask->Canvas->Font->Height = StoneImageSize*2/3;
	mask->Canvas->Font->Color = clBlack;
	mask->Canvas->Brush->Color = clWhite;
	str->Canvas->Font->Style = bold;
	str->Canvas->Font->Height = StoneImageSize*2/3;
	str->Canvas->Font->Color = debugFontColor;
	str->Canvas->Brush->Color = clBlack;
	shadow->Canvas->Font->Style = bold;
	shadow->Canvas->Font->Height = StoneImageSize*2/3;
	shadow->Canvas->Font->Color = shadowedDebugFontColor;
	shadow->Canvas->Brush->Color = clBlack;
	for ( int x = 0; Board::MaxX > x; x++ ) {
		for ( int y = 0; Board::MaxY > y; y++ ) {
			const int step = BoardImageLineStep;
			const int left = BoardImageLeftLine;
			const int top = BoardImageTopLine;
			int num = dbBoard.stones[ y ][ x ];
			if ( num == -128 )
				continue;
			const int textwidth = canvas->TextExtent( num ).cx + 1;
			str->Canvas->FillRect( str->Canvas->ClipRect );
			mask->Canvas->FillRect( mask->Canvas->ClipRect );
			mask->Canvas->TextOut( cw/2-textwidth/2, 0, num );
			str->Canvas->TextOut( cw/2-textwidth/2, 0, num );
			const int sx = left + x*step;
			const int sy = top + y*step;
			const int l = sx-cw/2;
			const int r = sx+cw/2;
			const int u = sy-ch/2;
			const int d = sy+ch/2;
			if ( ShadowedDebugFont->Checked ) {
				canvas->CopyMode = cmSrcAnd;
				canvas->CopyRect( TRect( l + 1, u + 0, r + 1, d + 0 ), mask->Canvas, mask->Canvas->ClipRect );
				canvas->CopyRect( TRect( l + 0, u + 1, r + 0, d + 1 ), mask->Canvas, mask->Canvas->ClipRect );
				canvas->CopyRect( TRect( l + 1, u + 1, r + 1, d + 1 ), mask->Canvas, mask->Canvas->ClipRect );
				canvas->CopyMode = cmSrcPaint;
				shadow->Canvas->FillRect( shadow->Canvas->ClipRect );
				shadow->Canvas->TextOut( cw/2-textwidth/2, 0, num );
				canvas->CopyRect( TRect( l + 1, u + 0, r + 1, d + 0 ), shadow->Canvas, shadow->Canvas->ClipRect );
				canvas->CopyRect( TRect( l + 0, u + 1, r + 0, d + 1 ), shadow->Canvas, shadow->Canvas->ClipRect );
				canvas->CopyRect( TRect( l + 1, u + 1, r + 1, d + 1 ), shadow->Canvas, shadow->Canvas->ClipRect );
			}
			canvas->CopyMode = cmSrcAnd;
			canvas->CopyRect( TRect( l, u, r, d ), mask->Canvas, mask->Canvas->ClipRect );
			canvas->CopyMode = cmSrcPaint;
			canvas->CopyRect( TRect( l, u, r, d ), str->Canvas, str->Canvas->ClipRect );
		}
	}
}

//---------------------------------------------------------------------------
AnsiString TIrenseiMainForm::GetMoveMessage( const Game::Move & move, int no )
{
	return AnsiString().sprintf( "% 4d %s : %02d - %02d", no, 
			(move.blackOrWhite == Game::EBWBlack) ? "" : "",
			move.x+1, move.y+1
	);
}
//---------------------------------------------------------------------------
void TIrenseiMainForm::UpdateMovesList( void )
{
	MovesList->Invalidate();
	MovesList->Clear();
	for ( int lpc = 0; game.CountMove() > lpc; lpc++ ) {
		MovesList->Items->Add( GetMoveMessage(game.GetMove(lpc), lpc) );
	}
	MovesList->ItemIndex = MovesList->Count - 1;
	MovesList->Update();
}
//---------------------------------------------------------------------------
void TIrenseiMainForm::StopGame( void )
{
	// `h
	AIFinalize( players[ Game::EBWBlack ].ai );
	AIFinalize( players[ Game::EBWWhite ].ai );

	// dll ̊J
	for ( std::vector< HMODULE >::iterator itor = aiModules.begin(); itor != aiModules.end(); itor++ ) {
		if ( *itor )
			FreeLibrary( *itor );
	}

	// th
	players[ Game::EBWBlack ].type = EPTypeNone;
	players[ Game::EBWWhite ].type = EPTypeNone;
	ChangeOrder( Game::EBWNone );
	undoButton->Disable();
	resignButton->Disable();
	UndoMenu->Enabled = false;
	ResignMenu->Enabled = false;

	blackSignBoard->SetType( SignBoard::ETNone );
	whiteSignBoard->SetType( SignBoard::ETNone );

	Caption = windowTitle;

	flagEndGame = true;
}
//---------------------------------------------------------------------------
void TIrenseiMainForm::GameOver( void )
{
	const Game::EBlackOrWhite won = game.NextOrder();
	const char * color = (won == Game::EBWBlack) ? "" : "";

	sndPlaySound( pResSoundJingle, SND_MEMORY | SND_ASYNC | SND_NODEFAULT );

	ShowMessage( AnsiString(color) + "̏ł" );

	StopGame();
}
//---------------------------------------------------------------------------
void TIrenseiMainForm::AIResign( void )
{
	const Game::EBlackOrWhite won = game.NextOrder( game.NextOrder() );
	const char * color = (won == Game::EBWBlack) ? "" : "";

	sndPlaySound( pResSoundJingle, SND_MEMORY | SND_ASYNC | SND_NODEFAULT );

	ShowMessage( AnsiString("Rs[^͓܂B") + color + "̏ł" );

	StopGame();
}
//---------------------------------------------------------------------------
void TIrenseiMainForm::ListPlayerTypes( void )
{
	playerTypes.clear();

	IRENSEI_AI_DESC player;
	memset( &player, 0, sizeof(IRENSEI_AI_DESC) );
	strcpy( player.name, "l" );
	playerTypes.push_back( player );

	// ftHg AI ǉ
	{
		MakeStrongAiDesc( &player );
		playerTypes.push_back( player );
	}

	// O AI ǉ
	{
		std::vector<std::string> dlls;
		// ai*.dll Ƃt@C
		TSearchRec sr;
		if ( FindFirst("ai*.dll", faArchive, sr) == 0 ) {
			do {
				dlls.push_back( sr.Name.c_str() );
			} while ( FindNext(sr) == 0);
			FindClose( sr );
		}
		// 񋓂AKiɍv̂ playerTypes ɒǉ
		for ( std::vector<std::string>::const_iterator itor = dlls.begin(); itor != dlls.end(); itor++ ) {
			HMODULE hmod = LoadLibrary( itor->c_str() );
			if ( hmod && MakeIrenseiAiDesc( &player, hmod ) ) {
				playerTypes.push_back( player );
				aiModules.push_back( hmod );
			}
		}
		AIParams1->Visible = ( playerTypes.size() > 2 );
	}

	// GameConditionDialog2 ̃Xg playerTypes o^
	GameConditionDialog2->SetPlayerTypes( playerTypes );
}
//---------------------------------------------------------------------------
void TIrenseiMainForm::StartGame( void )
{
	if ( players[ Game::EBWBlack ].type == EPTypeNone )
		ListPlayerTypes();		// Q[OȂAV
	else
		;						// Q[Ȃ炳̂
	if ( mrOk != GameConditionDialog2->ShowModal() ) {
		if ( players[ Game::EBWBlack ].type == EPTypeNone )
			StopGame();				// Xĝ߂ɃbN DLL J
		return;
	}

	// AI ĂΎE
	AIFinalize( players[ Game::EBWBlack ].ai );
	AIFinalize( players[ Game::EBWWhite ].ai );


	const EPlayerType blackPlayer = GameConditionDialog2->BlackPlayer->ItemIndex == 0 ? EPTypeUser : EPTypeComputer;
	const EPlayerType whitePlayer = GameConditionDialog2->WhitePlayer->ItemIndex == 0 ? EPTypeUser : EPTypeComputer;
	players[ Game::EBWBlack ].type = blackPlayer;
	players[ Game::EBWWhite ].type = whitePlayer;
	players[ Game::EBWBlack ].side = Game::EBWBlack;
	players[ Game::EBWWhite ].side = Game::EBWWhite;

	game.Reset();
	// @@ rule ̃o[W`FbŃArule ύXƂɁAs
	if ( blackPlayer == EPTypeComputer || whitePlayer == EPTypeComputer )
		currule = &rule100;		// AI gpꍇ́AJŃ[
	else
		currule = &rule99;			// Ȃꍇ́A͈͂[
	game.SetRule( *currule );

	// AI w
	SetAI( players[ Game::EBWBlack ], currule, GameConditionDialog2->BlackPlayer->ItemIndex );
	SetAI( players[ Game::EBWWhite ], currule, GameConditionDialog2->WhitePlayer->ItemIndex );
	// AI fobONA
	memset( dbBoard.stones, -128, sizeof(dbBoard.stones) );


	MovesList->Clear();

	ChangeOrder( game.NextOrder() );
	flagNewGameStarted = true;

	blackSignBoard->SetType( (blackPlayer==whitePlayer) ? SignBoard::ETSame : (blackPlayer == EPTypeComputer) ? SignBoard::ETCpu : SignBoard::ETUser );
	whiteSignBoard->SetType( (blackPlayer==whitePlayer) ? SignBoard::ETSame : (whitePlayer == EPTypeComputer) ? SignBoard::ETCpu : SignBoard::ETUser );
	blackSignBoard->Change( true );
	whiteSignBoard->Change( false );

	Caption = AnsiString() + ":" + playerTypes[ GameConditionDialog2->BlackPlayer->ItemIndex ].name + 
			" vs :" + playerTypes[ GameConditionDialog2->WhitePlayer->ItemIndex ].name;


	flagEndGame = false;
	UpdateImage();
}
//---------------------------------------------------------------------------
void TIrenseiMainForm::SetAI( PlayerDesc & desc, const IRENSEI_RULE_DESCRIPTION * rule, int id )
{
	if ( desc.type == EPTypeComputer ) {
		memcpy( &desc.ai, &playerTypes[ id ], sizeof(IRENSEI_AI_DESC) );	// @@ AIParam ԂĂ͂Ȃ
		desc.ai.param = (*desc.ai.initialize)( rule, desc.side, desc.ai.iout );
		if ( ! desc.ai.param ) {
			ShowMessage(AnsiString(desc.ai.name) + "͖肪悤Ȃ̂ŁAԂ͐lԂƂ܂");
			desc.type = EPTypeUser;
		}
		if ( desc.ai.logWindow )
			desc.ai.logWindow->Caption = desc.color + " : " + desc.ai.name;
	}
}
//---------------------------------------------------------------------------
void TIrenseiMainForm::ChangeOrder( Irensei::Game::EBlackOrWhite order )
{
	blackSignBoard->Change( order == Game::EBWBlack );
	whiteSignBoard->Change( order == Game::EBWWhite );

	bool flagComputer = players[ order ].type == EPTypeComputer;
	bool flagUser     = players[ order ].type == EPTypeUser;
	const PlayerDesc & other = players[ game.NextOrder(order) ];
	bool flagUndo = flagUser && (other.type == EPTypeUser || other.ai.undo != 0);
			// undo \ȏ́AԂ[UŁA肪[U undo \ AI ł邱

	undoButton->Enable( flagUndo );
	resignButton->Enable( flagUser );
	UndoMenu->Enabled = flagUndo;
	ResignMenu->Enabled = flagUser;

	// Rs[^̎ԂȂvlJn
	if ( flagComputer ) {
		flagSuspended = false;
		flagNewGameStarted = false;
		Application->ProcessMessages();		// ł̏ WM_APP ƍ
		if ( ! flagNewGameStarted/* UȂ ProcessMessages() ɓĂȂ */
				|| flagSuspended/* ProcessMessages() ɖ̂𓊂 */
		) {
			PostMessage( Handle, WM_APP, game.CountMove(), 0 );
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TIrenseiMainForm::WndProc(Messages::TMessage &Message)
{
	switch ( Message.Msg ) {
		case WM_APP:
		{
			ASSERT( Message.WParam == game.CountMove() );
			if ( flagThinking ) {
				flagSuspended = true;
			} else {
				flagThinking = true;
				AIThink();
				flagThinking = false;
			}
			break;
		}
		default:
			TForm::WndProc( Message );
	}
}
//---------------------------------------------------------------------------
void TIrenseiMainForm::AIThink( void )
{
	IRENSEI_BOARD_POSITION * lastMove;
	IRENSEI_BOARD_POSITION lm;
	if ( game.CountMove() ) {
		Game::Move move = game.GetLastMove();
		lm.x = move.x;
		lm.y = move.y;
		lastMove = &lm;
	} else {
		lastMove = 0;
	}

	IRENSEI_BOARD_POSITION commove;
	AIParam & ai = players[ game.NextOrder() ].ai;
	int airesign = ! (*ai.think)( ai.param, &commove, lastMove, ai.iout )/* vl[`Ăяo */;
	AIDebug( ai );
	if ( airesign ) {
		// `h̎vl[`̃G[BƂĈ܂
		AIResign();
	} else {
		Game::EMoveResult result = game.NewMove( commove.x, commove.y );
		switch ( result ) {
			case Game::EMResultNonSpace:	// łɐ΂
			case Game::EMResultSuicide:	// E
			case Game::EMResultKou:		// 
			case Game::EMResultTooLong:	// A
				IrenseiPrintf( ai.hout, " sys:(%d, %d) ͔", commove.x, commove.y );
				AIResign();
				return;
			case Game::EMResultWin:
				flagEndGame = true;
				break;
		}
		if ( players[ game.NextOrder(game.NextOrder()) ].type != EPTypeComputer )	// Rs[^m̂Ƃ́A邳炳Ȃ
			sndPlaySound( pResSoundMove, SND_MEMORY | SND_ASYNC | SND_NODEFAULT );

		if ( game.GetLastMove().cntNuki > 0 )
			sndPlaySound( pResSoundButton, SND_MEMORY | SND_ASYNC | SND_NODEFAULT );

		MovesList->Items->Add( GetMoveMessage(game.GetLastMove(), game.CountMove()) );
		MovesList->ItemIndex = MovesList->Count - 1;

		if ( result == Game::EMResultWin ) {
			flagEndGame = true;
			UpdateImage();
			GameOver();
		}
		else {
			UpdateImage();
			ChangeOrder( game.NextOrder() );
		}
	}
}
//---------------------------------------------------------------------------
void TIrenseiMainForm::AIDebug( const AIParam & ai )
{
	if ( ! ai.debug )
		return;
	if ( ai.countDebug <= DebugID || DebugID < 0 )
		return;

	memset( dbBoard.stones, -128, sizeof(dbBoard.stones) );
	(*ai.debug)( ai.param, &dbBoard, DebugID, ai.iout );
}

//---------------------------------------------------------------------------
void __fastcall TIrenseiMainForm::GotoIrenseiHomePage(TObject *Sender)
{
	ShellExecute(NULL, "open", "http://irensei.com/", NULL, NULL, SW_SHOWNORMAL); 
}
//---------------------------------------------------------------------------
void __fastcall TIrenseiMainForm::X1Click(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TIrenseiMainForm::A1Click(TObject *Sender)
{
	SplashForm->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::NewGameButtonClick(TObject *Sender)
{
	StartGame();
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::N1Click(TObject *Sender)
{
	StartGame();
}
//---------------------------------------------------------------------------
void __fastcall TIrenseiMainForm::BoardImageMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if ( Button == mbLeft )
		Move( X, Y );
}
//---------------------------------------------------------------------------
void TIrenseiMainForm::Move( int X, int Y )
{
	// [U̎ԂȂ΋A
	if ( players[ game.NextOrder() ].type != EPTypeUser )
		return;

	// NbNꏊAH𓾂
	const int step = BoardImageLineStep;
	const int left = BoardImageLeftLine;
	const int top = BoardImageTopLine;
	int x = (X - left + step/2) / step;
	int y = (Y - top + step/2) / step;
	if ( x < 0 || y < 0 )
		return;		// ՊǑx͟T
	if ( Board::MaxX <= x || Board::MaxY <= y )
		return;		// ՊǑx͟T

	Game::EMoveResult result = game.NewMove( x, y );
	switch ( result ) {
		case Game::EMResultNonSpace:	// łɐ΂
			ShowMessage( "ɂ͐΂̂Œu܂" );
			return;
		case Game::EMResultSuicide:	// E
			ShowMessage( "͎Eł̂Œu܂" );
			return;
		case Game::EMResultKou:		// 
			ShowMessage( "͍(RE)Ȃ̂Œu܂" );
			return;
		case Game::EMResultTooLong:	// A
			ShowMessage( "Ԃ̒A͔Ȃ̂ŁAɂ͒u܂" );
			return;
		case Game::EMResultWin:		// VAŏ
			break;
		case Game::EMResultOK:
		default:
			break;
	}
	sndPlaySound( pResSoundMove, SND_MEMORY | SND_ASYNC | SND_NODEFAULT );
	if ( game.GetLastMove().cntNuki > 0 )
		sndPlaySound( pResSoundButton, SND_MEMORY | SND_ASYNC | SND_NODEFAULT );

	MovesList->Items->Add( GetMoveMessage(game.GetLastMove(), game.CountMove()) );
	MovesList->ItemIndex = MovesList->Count - 1;

	if ( result == Game::EMResultWin ) {
		flagEndGame = true;
		UpdateImage();
		GameOver();
	}
	else {
		UpdateImage();
		ChangeOrder( game.NextOrder() );
	}
}
//---------------------------------------------------------------------------
void TIrenseiMainForm::AIFinalize( TIrenseiMainForm::AIParam & ai )
{
	if ( ai.param ) {
		ASSERT( (*ai.finalize)(ai.param, ai.iout) );
		ai.param = 0;
	}
}

//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::UndoButtonClick(TObject *Sender)
{
	const PlayerDesc & other = players[ game.NextOrder( game.NextOrder() ) ];
	for ( int lpc = 0; 2 > lpc; lpc++ ) {
		if ( game.CountMove() ) {
			game.Undo();
			const AIParam & ai = other.ai;
			if ( other.type == EPTypeComputer && ai.undo ) {
				IRENSEI_BOARD_POSITION ailm;				// ai last move
				Game::Move gamelm = game.GetLastMove();		// game last move

				bool flagFailed = ! (*ai.undo)( ai.param, &ailm, ai.iout );
				if ( flagFailed || gamelm.x != ailm.x || gamelm.y != ailm.y ) {
					AIResign();			// undo sBƂĈ܂
					return;
				}
			}
		}
	}

	ChangeOrder( game.NextOrder() );
	UpdateMovesList();
	UpdateImage();
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::ResignButtonClick(TObject *Sender)
{
	const Game::EBlackOrWhite won = game.NextOrder( game.NextOrder() );
	const AnsiString color = (won == Game::EBWBlack) ? "" : "";

	sndPlaySound( pResSoundJingle, SND_MEMORY | SND_ASYNC | SND_NODEFAULT );

	ShowMessage( AnsiString(color) + "̏ł" );

	StopGame();
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::SettingsMenuItemClicked(TObject *Sender)
{
	TMenuItem * item = dynamic_cast<TMenuItem*>(Sender);
    item->Checked = ! item->Checked;
    UpdateImage();
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if ( Shift.Contains( ssShift ) && Shift.Contains( ssCtrl ) && Key == VK_F1 ) {
		RuleChangingDialog->LineLength->Position        = rule99.lineLength;
		RuleChangingDialog->OuterInvalidLines->Position = rule99.outerInvalidLines;
		if ( RuleChangingDialog->ShowModal() == mrOk ) {
			rule99.lineLength        = RuleChangingDialog->LineLength->Position;
			rule99.outerInvalidLines = RuleChangingDialog->OuterInvalidLines->Position;
		}
		return;
	}
	if ( Shift.Contains( ssCtrl ) ) {
		switch ( Key ) {
			case 'C':
			case 'c':
				Clipboard()->Assign( BoardImage->Picture->Bitmap );
				break;
			default:
				break;
		}
		return;
	}
	switch ( Key ) {
		default:
			break;
	}
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::ShowLogWindow1Click(TObject *Sender)
{
	if ( players[ Game::EBWBlack ].ai.logWindow )
		players[ Game::EBWBlack ].ai.logWindow->Show();
	if ( players[ Game::EBWWhite ].ai.logWindow )
		players[ Game::EBWWhite ].ai.logWindow->Show();
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::MovesListClick(TObject *Sender)
{
	// Q[f
	if ( players[ Game::EBWBlack ].type == EPTypeNone )
		UpdateImage();
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::debugid1Click(TObject *Sender)
{
	DebugIDDialog->DebugID->Position = DebugID;
	if ( DebugIDDialog->ShowModal() == mrOk ) {
		DebugID = DebugIDDialog->DebugID->Position;
		memset( dbBoard.stones, -128, sizeof(dbBoard.stones) );
		UpdateImage();
	}
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::debugfontcolor1Click(TObject *Sender)
{
	if ( DebugFontColorDialog->Execute() ) {
		debugFontColor = DebugFontColorDialog->Color;
		UpdateImage();
	}
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::shadowcolor1Click(TObject *Sender)
{
	if ( DebugFontShadowColorDialog->Execute() ) {
		shadowedDebugFontColor = DebugFontShadowColorDialog->Color;
		UpdateImage();
	}
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::ShadowedDebugFontClick(TObject *Sender)
{
    ShadowedDebugFont->Checked = ! ShadowedDebugFont->Checked;
	shadowcolor1->Enabled = ShadowedDebugFont->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::RightPaneImageMouseDown(
      TObject *Sender, TMouseButton Button, TShiftState Shift, int X,
      int Y)
{
	GameButton * button = GetButtonUnder( X, Y );
	if ( button ) {
		sndPlaySound( pResSoundButton, SND_MEMORY | SND_ASYNC | SND_NODEFAULT );
		buttonUnderPressed = button;
		button->Down();
	}
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::RightPaneImageMouseMove(
      TObject *Sender, TShiftState Shift, int X, int Y)
{
	const GameButton * button = GetButtonUnder( X, Y );
	if		( ! button ) {
		Cursor = crDefault;
		if ( buttonUnderPressed && buttonUnderPressed->Pressed() ) {
			buttonUnderPressed->Up();
		}
	}
	else {
		if ( ! buttonUnderPressed ) {
			Cursor = crHandPoint;
		}
		else {
			if ( button == buttonUnderPressed ) {	// ߂Ă
				Cursor = crHandPoint;
				if ( ! buttonUnderPressed->Pressed() )
					buttonUnderPressed->Down();
			}
			else {
				Cursor = crDefault;
				if ( buttonUnderPressed->Pressed() )
					buttonUnderPressed->Up();
			}
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::RightPaneImageMouseUp(
      TObject *Sender, TMouseButton Button, TShiftState Shift, int X,
      int Y)
{
	GameButton * button = GetButtonUnder( X, Y );
	if ( button && button == buttonUnderPressed ) {
		buttonUnderPressed->Invoke( this );
	}
	if ( buttonUnderPressed ) {
		buttonUnderPressed->Up();
	}
	buttonUnderPressed = 0;
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::BoardImageMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
	Cursor = crDefault;		// Ȃ
}
//---------------------------------------------------------------------------

TIrenseiMainForm::GameButton * TIrenseiMainForm::GetButtonUnder( int x, int y )
{
	for ( std::vector<GameButton*>::iterator itor = gameButtons.begin(); itor != gameButtons.end(); itor++ ) {
		if ( (*itor)->Under( x, y ) )
			return *itor;
	}
	return 0;
}
//---------------------------------------------------------------------------
static const char * bw2str( Game::EBlackOrWhite bw )
{
	static const char * str[] = { "B", "W" };
	const int types = sizeof(str)/sizeof(str[0]);
	int lpc;
	for ( lpc = 0; types > lpc; lpc++ ) {
		if ( bw == (1<<lpc) )
			break;
	}
	if ( lpc < types )
		return str[ lpc ];
	return "";
}
static AnsiString game2sgf( const Game & game, const IRENSEI_RULE_DESCRIPTION & rule )
{
	AnsiString result;

	result += "(";
	result += AnsiString() + ";SZ[" + std::max(Board::MaxX, Board::MaxY) + "]";

	for ( int lpc = 0; game.CountMove() > lpc; lpc++ ) {
		if ( (lpc & 0x07) == 0 )
			result += "\r\n";
		const Game::Move move = game.GetMove(lpc);
		result += AnsiString() + ";" + bw2str( move.blackOrWhite );
		result += AnsiString().sprintf( "[%c%c]", move.x + 'a', move.y + 'a' );
	}

	result += ")\r\n";
	return result;;
}
static AnsiString game2text( const Game & game, const IRENSEI_RULE_DESCRIPTION & rule )
{
	AnsiString result;
	static const char * cross[3][3] = { { "", "", "" },{  "", "", "" }, { "", "", "" } };
	static const char * stones[] = { "", "", "", "" };
	static const char * lasts[]  = { "", "", "", "" };
	const int stonetypes = std::max( sizeof(stones)/sizeof(stones[0]), sizeof(lasts)/sizeof(lasts[0]) );

	const int outer = rule.outerInvalidLines;
	const int left   = outer;
	const int top    = outer;
	const int right  = Board::MaxX - outer;
	const int bottom = Board::MaxY - outer;

	const Board * board = game.GetBoard();
	const Game::Move lm = game.GetLastMove();
	for ( int y = 0; y < Board::MaxY; y++ ) {
		for ( int x = 0; x < Board::MaxX; x++ ) {
			const Board::EStone stone = board->Get( x, y );
			if ( stone != Board::EStoneSpace ) {
				int lpc;
				for ( lpc = 0; lpc < stonetypes; lpc++ ) {
					if ( stone == (1 << lpc) )
						break;
				}
				if ( lpc < stonetypes ) {
					if ( lm.x == x && lm.y == y ) {
						result += lasts[lpc];
					} else {
						result += stones[lpc];
					}
				}
			}
			else {
				int v = 1, h = 1;	// 1 ͐^
				if      ( board->Get( x - 1, y     ) == Board::EStoneOutOfBounds )	h = 0;
				else if ( board->Get( x + 1, y     ) == Board::EStoneOutOfBounds )	h = 2;
				if      ( board->Get( x    , y - 1 ) == Board::EStoneOutOfBounds )	v = 0;
				else if ( board->Get( x    , y + 1 ) == Board::EStoneOutOfBounds )	v = 2;

				if ( v == 1 && h == 1 && x >= left && x < right && y >= top && y < bottom ) {
					result += "";
				} else {
					result += cross[ v ][ h ];
				}
			}
		}
		result += "\r\n";
	}
	return result;
}
//---------------------------------------------------------------------------
void __fastcall TIrenseiMainForm::importfromclipboard1Click(
      TObject *Sender)
{
//	
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::exporttoclipboard1Click(TObject *Sender)
{
	Clipboard()->AsText = game2sgf( game, *currule );
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::importfromfiles1Click(TObject *Sender)
{
	      //
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::exporttofileS1Click(TObject *Sender)
{
	ExportToFileDialog->Title = "SGF `ł̏o";
	ExportToFileDialog->DefaultExt = ".sgf";
	ExportToFileDialog->Filter = "sgf file(*.sgf)|*.sgf|any file(*.*)|*.*";
	ExportToFileDialog->FileName = "";
	if ( ExportToFileDialog->Execute() ) {
		AnsiString sgf = game2sgf( game, *currule );
		TFileStream * file;
		try {
			file = new TFileStream( ExportToFileDialog->FileName, fmCreate | fmShareExclusive );
			file->Write( sgf.c_str(), sgf.Length() );
			delete file;
			ExportToFileDialog->InitialDir = ExtractFilePath( ExportToFileDialog->FileName );
		} catch (...) {
			ShowMessage( "ۑɎs܂" );
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::ImportFromClipboard2Click(
      TObject *Sender)
{
	  //
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::ExportToClipboard2Click(TObject *Sender)
{
	Clipboard()->AsText = game2text( game, *currule );
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::ImportFromFileL1Click(TObject *Sender)
{
  //	
}
//---------------------------------------------------------------------------

void __fastcall TIrenseiMainForm::ExportToFileS2Click(TObject *Sender)
{
	ExportToFileDialog->Title = "eLXg`ł̏o";
	ExportToFileDialog->DefaultExt = ".txt";
	ExportToFileDialog->Filter = "text file|*.txt|any file|*.*";
	ExportToFileDialog->FileName = "";
	if ( ExportToFileDialog->Execute() ) {
		AnsiString textboard = game2text( game, *currule );
		TFileStream * file;
		try {
			file = new TFileStream( ExportToFileDialog->FileName, fmCreate | fmShareExclusive );
			file->Write( textboard.c_str(), textboard.Length() );
			delete file;
			ExportToFileDialog->InitialDir = ExtractFilePath( ExportToFileDialog->FileName );
		} catch (...) {
			ShowMessage( "ۑɎs܂" );
		}
	}
}
//---------------------------------------------------------------------------


void __fastcall TIrenseiMainForm::I1Click(TObject *Sender)
{
	ShellExecute(NULL, "open", ".\\online_help\\index.html", NULL, NULL, SW_SHOWNORMAL); 
}
//---------------------------------------------------------------------------

