//---------------------------------------------------------------------------

#ifndef mainformH
#define mainformH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <Graphics.hpp>
#include "game.h"
#include <ImgList.hpp>
#include "irensei_rule_description.h"
#include "irensei_ai_descripter.h"
#include <Dialogs.hpp>
#include <Buttons.hpp>
#include <vector>
#include <map>
#include "LogWindow.h"
class SignBoard;
//---------------------------------------------------------------------------

class TIrenseiMainForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TMainMenu *MainMenu1;
	TMenuItem *F1;
	TMenuItem *N1;
	TMenuItem *N2;
	TMenuItem *X1;
	TMenuItem *G1;
	TMenuItem *UndoMenu;
	TMenuItem *ResignMenu;
	TMenuItem *H3;
	TMenuItem *I1;
	TMenuItem *A1;
	TMenuItem *Settings1;
	TMenuItem *AIParams1;
	TMenuItem *W1;
	TMenuItem *Note1;
	TMenuItem *AtariMenu;
	TMenuItem *ReachMenu;
	TMenuItem *ReachFor1Menu;
	TMenuItem *ReachFor2Menu;
	TMenuItem *ShowLogWindow1;
	TMenuItem *debugid1;
	TMenuItem *debugfontcolor1;
	TColorDialog *DebugFontColorDialog;
	TMenuItem *ShadowedDebugFont;
	TMenuItem *shadowcolor1;
	TColorDialog *DebugFontShadowColorDialog;
	TListBox *MovesList;
	TImage *BoardImageHolder;
	TImage *RightPaneImage;
	TImageList *ResignButtonImages;
	TImageList *UndoButtonImages;
	TImageList *NewgameButtonImages;
	TMenuItem *sgf1;
	TMenuItem *importfromclipboard1;
	TMenuItem *exporttoclipboard1;
	TMenuItem *importfromfiles1;
	TMenuItem *exporttofileS1;
	TMenuItem *textboard1;
	TMenuItem *ImportFromClipboard2;
	TMenuItem *ExportToClipboard2;
	TMenuItem *ImportFromFileL1;
	TMenuItem *ExportToFileS2;
	TImage *BoardImage;
	TSaveDialog *ExportToFileDialog;
	TMenuItem *N3;
	TMenuItem *LastMoveMenu;
	TImage *RightPaneImageHolder;
	TImage *BlackSignImages;
	TImage *WhiteSignImages;
	void __fastcall GotoIrenseiHomePage(TObject *Sender);
	void __fastcall X1Click(TObject *Sender);
	void __fastcall A1Click(TObject *Sender);
	void __fastcall NewGameButtonClick(TObject *Sender);
	void __fastcall N1Click(TObject *Sender);
	void __fastcall BoardImageMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall UndoButtonClick(TObject *Sender);
	void __fastcall ResignButtonClick(TObject *Sender);
	void __fastcall SettingsMenuItemClicked(TObject *Sender);
	void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
	void __fastcall ShowLogWindow1Click(TObject *Sender);
	void __fastcall MovesListClick(TObject *Sender);
	void __fastcall debugid1Click(TObject *Sender);
	void __fastcall debugfontcolor1Click(TObject *Sender);
	void __fastcall shadowcolor1Click(TObject *Sender);
	void __fastcall ShadowedDebugFontClick(TObject *Sender);
	void __fastcall RightPaneImageMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall RightPaneImageMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
	void __fastcall RightPaneImageMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall BoardImageMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
	void __fastcall importfromclipboard1Click(TObject *Sender);
	void __fastcall exporttoclipboard1Click(TObject *Sender);
	void __fastcall importfromfiles1Click(TObject *Sender);
	void __fastcall exporttofileS1Click(TObject *Sender);
	void __fastcall ImportFromClipboard2Click(TObject *Sender);
	void __fastcall ExportToClipboard2Click(TObject *Sender);
	void __fastcall ImportFromFileL1Click(TObject *Sender);
	void __fastcall ExportToFileS2Click(TObject *Sender);
	void __fastcall I1Click(TObject *Sender);
private:	// [U[錾
	Irensei::Game game;
	IRENSEI_RULE_DESCRIPTION rule99;
	IRENSEI_RULE_DESCRIPTION rule100;
	const IRENSEI_RULE_DESCRIPTION * currule;

	void StopGame( void );
	void StartGame( void );
	void GameOver( void );

	void ChangeOrder( Irensei::Game::EBlackOrWhite order );

	void Move( int X, int Y );		// PłB̓Rg[̍W



	void ListPlayerTypes( void );	// AI, lbg[NvC[Ȃǂ̈ꗗ쐬ƁA
								// GameConditionDlg2 ̃Xg{bNXݒ
	std::vector< IRENSEI_AI_DESC > playerTypes;
	std::vector< HMODULE > aiModules;	// dll Ĵ

	struct AIParam : public IRENSEI_AI_DESC {
		AIParam() : param(0), logWindow(0)		{};
		int param;
		union {
			HANDLE hout;
			int iout;
		};
		TIrenseiLogWindow * logWindow;
	};

	enum EPlayerType {
		EPTypeNone,
		EPTypeUser,
		EPTypeComputer,
		EPTypeNetwork
	};

	void AIThink( void );
	void AIResign( void );
	void AIFinalize( AIParam & ai );
	void AIDebug( const AIParam & ai );


	struct PlayerDesc {		// TIrenseiMainForm ̃RXgN^Őݒ肳B
							// ȍ~Aϕ ai  param  IRENSEI_AI_DESC 
		EPlayerType type;
		AIParam ai;
		Irensei::Game::EBlackOrWhite side;
		AnsiString color;
		SignBoard * signboard;
	};
	std::map< Irensei::Game::EBlackOrWhite, PlayerDesc > players;


	void SetLogPipe( PlayerDesc & desc);
	void SetAI( PlayerDesc & desc, const IRENSEI_RULE_DESCRIPTION * rule, int id );


	void DrawAtari( const Irensei::Board * board );
	void DrawReaches( const Irensei::Board * board );
	void DrawGoal( const Irensei::Board * board );		// VA\
	void DrawLastMove( void );
	bool flagEndGame;			// t炠⃊[`\Ȃ
	AnsiString GetMoveMessage( const Irensei::Game::Move & move, int no );

	const char * getNormalStoneImage( Irensei::Board::EStone stone );
	const char * getReachStoneImage( Irensei::Board::EStone stone );
	const char * getDyingStoneImage( Irensei::Board::EStone stone );
	const char * getLastStoneImage( Irensei::Board::EStone stone );
	const char * getGoalMarkImage( Irensei::Board::EStone stone );
	const char * getAtariPointImage( Irensei::Board::EStone stone );
	const char * getReachPointImage( Irensei::Board::EStone stone );

	bool flagDeepColor;
	bool flagDrawReachAfterAtari;
	bool flagDrawLastMoveFirst;


	// AI sp̃bZ[W𓊂OɁAthɔ邽߂ ProcessMessages()邪A
	// ̂ƂuVK΋ǁvs AI sbZ[WĂ܂A
	// AI sċAĂ܂BhB
	bool flagThinking;			// AI sp̃bZ[Ws͎AI sp̃bZ[WubN
	bool flagSuspended;			// ubN
	// AI sp̃bZ[WsAI sp̃bZ[W𓊂̂́uVKJnv̂݁B
	// oB
	bool flagNewGameStarted;

	IRENSEI_DEBUG_BOARD dbBoard;
	int DebugID;
	TColor debugFontColor;
	TColor shadowedDebugFontColor;
	void DrawDebugBoard( TCanvas * canvas ) const;



	// {^BςȂȎBS󂢃Rs[
	class GameButton {		// EyC̃{^B}Ȃ`悷邽߂ɎO
		GameButton();	// ֎~
	public:
		GameButton( const TRect & r, TImage * owner, TImageList * imgs, void (__closure*f)( void ) )
			: rect(r), Images(imgs), Owner(owner), func(f), pressed(false), enabled(true) {}
		GameButton( const GameButton & o )
			: rect(o.rect), Images(o.Images), Owner(o.Owner), func(o.func), pressed(o.pressed), enabled(o.enabled) {}
		bool Under( int x, int y ) const  { return (enabled && x >= rect.Left && x < rect.Right && y >= rect.Top && y < rect.Bottom); }
		void Down( void )	{ pressed = true; Redraw(); }
		void Up( void )		{ pressed = false; Redraw(); }
		void Enable( void )	{ enabled = true; Redraw(); }
		void Disable( void ){ enabled = false; Redraw(); }
		void Enable( bool b ) { enabled = b; Redraw(); }
		void Redraw( void ) const	{
				if ( Images ) {
					Owner->Invalidate();
					Images->Draw( Owner->Canvas, rect.Left, rect.Top, (!enabled) ? 2 : (pressed ? 1 : 0) );
					Owner->Update();
				}
		}
		void Invoke( TIrenseiMainForm * i ) const { func(); }
		bool Enabled( void )	{ return enabled; }
		bool Pressed( void )	{ return pressed; }
	private:
		bool enabled;
		bool pressed;
		TRect rect;
		TImage * Owner;
		TImageList * Images;
		void (__closure*func)( void );
	};
	std::vector<GameButton*> gameButtons;
	GameButton * GetButtonUnder( int x, int y );
	GameButton * buttonUnderPressed;

	GameButton * newgameButton;
	void newgameButtonPressed( void )		{NewGameButtonClick(0);}
	GameButton * undoButton;
	void undoButtonPressed( void )		{UndoButtonClick(0);}
	GameButton * resignButton;
	void resignButtonPressed( void )	{ResignButtonClick(0);}
	GameButton * logoButton;
	void logoButtonPressed( void )		{GotoIrenseiHomePage(0);}


	SignBoard * blackSignBoard;
	SignBoard * whiteSignBoard;


	HANDLE hResSoundMove;
	const char * pResSoundMove;
	HANDLE hResSoundButton;
	const char * pResSoundButton;
	HANDLE hResSoundJingle;
	const char * pResSoundJingle;




public:		// [U[錾
	__fastcall TIrenseiMainForm(TComponent* Owner);
	__fastcall ~TIrenseiMainForm();

	void UpdateImage( void );
	void UpdateMovesList( void );

	void __fastcall WndProc(Messages::TMessage &Message);
};
//---------------------------------------------------------------------------
extern PACKAGE TIrenseiMainForm *IrenseiMainForm;
//---------------------------------------------------------------------------
#endif
